this.name = "Galactic Misjump";
this.description = "Testing";

this.startUp = function() {
		this.gmj_active = 0;
}

this.debug = function(msg) {
//		log(this.name,msg);
}

this.playerStartedJumpCountdown = function(type,delay) {
		if (type == "galactic") {
				this.debug("Starting galactic countdown: "+delay);
				this.timer2 = new Timer(this,this.checkAngle,delay-0.5);
				this.timer = new Timer(this,this.checkMisjump,delay-0.1);
		} else if (this.gmj_active == 1) {
				player.ship.scriptedMisjump = true;
		} else {
				this.gmj_active = 0;
		}
}

this.playerCancelledJumpCountdown = function() {
		if (this.timer) {
				this.timer.stop();
				delete this.timer;
		}
		if (this.timer2) {
				this.timer2.stop();
				delete this.timer2;
		}
}

this.checkAngle = function() {
		this.oldangle = player.ship.vectorForward.direction();
}

this.checkPitch = function() {
		if (player.ship.pitch) { // 1.77
				this.debug("New pitch check");
				if (player.ship.pitch >= 0.95 || player.ship.pitch <= -0.95) {
						return true;
				} else {
						return false;
				}
		} else { // 1.76
				var angle = this.oldangle.dot(player.ship.vectorForward.direction());
				this.debug("Old pitch check = "+angle);
				if (angle < 0.95) {
						return true;
				} else {
						return false;
				}
		}
}

this.checkMisjump = function() {
		this.debug("Checking misjump");
		if (this.checkPitch()) {
				this.debug("Pitch extreme");
				var jumper = system.addShips("gmj_misjumper",1,[15E5,15E5,15E5],1)[0];
				jumper.scriptedMisjump = true;
				if (jumper.exitSystem()) {
						this.debug("Misjump prepared");
						player.ship.position = [15E5,15E5,15E5];
						this.gmj_active = 1;
						player.ship.setEquipmentStatus("EQ_GAL_DRIVE","EQUIPMENT_DAMAGED");
						this.killCount = 0;
				} else {
						this.debug("Misjump switch failed");
				}
		} else {
				this.debug("Pitch okay");
				this.gmj_active = 0;
				player.ship.scriptedMisjump = false;
		}
}

this.shipWillExitWitchspace = function() {
		if (!system.isInterstellarSpace) {
				this.gmj_active = 0;
		}
		if (this.gmj_active == 1) {
				this.debug("Misjump complete");
				this.timer.stop();
				this.timer = new Timer(this,this.repairGalDrive,1000);

				System.infoForSystem(galaxyNumber,player.ship.targetSystem).name = "Intergalactic space";
				player.ship.position = [0,0,1E6];
				system.addShips("thargoid",20+Math.floor(Math.random()*21),[0,0,1E6+35E3],20E3);
				system.addShips("gmj_navalsidewinder",10+Math.floor(Math.random()*21),[0,0,1E6+35E3],20E3);
				system.addShips("gmj_navalasp",5+Math.floor(Math.random()*11),[0,0,1E6+35E3],20E3);
				if (missionVariables.conhunt == "MISSION_COMPLETE" && Math.random() < 0.1) {
						system.addShips("gmj_navalconstrictor",10,[0,0,1E6+35E3],20E3);
				}
				if (Math.random() < 0.2) {
						system.addMoon("gmj_rogue_planet");
				}
		}
}

this.resetGMJ = this.shipWillEnterWitchspace = function() {
		if (this.gmj_active == 0 && System.infoForSystem(galaxyNumber,player.ship.targetSystem).name == "Intergalactic space") {
				System.infoForSystem(galaxyNumber,player.ship.targetSystem).name = null;
		} else if (this.gmj_active == 1) {
				player.ship.scriptedMisjump = true;
		}
}

this.shipExitedWitchspace = function() {
		if (this.gmj_active == 1) {
				if (!system.isInterstellarSpace) {
// player has escaped by nefarious means
						this.gmj_active = 0;
						this.resetGMJ();
				} else {

						if (player.ship.equipmentStatus("EQ_GAL_DRIVE") == "EQUIPMENT_DAMAGED") {
								player.consoleMessage("WARNING! Galactic Hyperdrive Malfunction!",10);
								player.consoleMessage("Attempting recalibration with remaining charge...",5);
						}
						player.ship.scriptedMisjump = true;
				}
		}
}

this.guiScreenChanged = function(from,to) {
		if (this.gmj_active == 1) {
				if (guiScreen == "GUI_SCREEN_SYSTEM_DATA" || guiScreen == "GUI_SCREEN_SHORT_RANGE_CHART" || guiScreen == "GUI_SCREEN_LONG_RANGE_CHART") {
						mission.runScreen({title: "Critical error",
															 message: "Unable to determine location - cannot load galactic chart data.",
															 allowInterrupt: true});
				}
		}
}

this.shipKilledOther = function(whom,damageType) {
		if (this.gmj_active == 1) {
				this.killCount++;
				if (this.killCount == 10 && player.ship.equipmentStatus("EQ_GAL_DRIVE") == "EQUIPMENT_DAMAGED") {
						this.timer.stop();
						this.timer = new Timer(this,this.repairGalDrive,20);
				}
		}
}

this.repairGalDrive = function() {
		player.ship.setEquipmentStatus("EQ_GAL_DRIVE","EQUIPMENT_OK");
		player.consoleMessage("Galactic Hyperdrive recalibration complete. Remaining charge sufficient to complete jump.",10);
}